import threading
from PyQt5 import QtCore, QtWidgets, QtGui
from PyQt5.QtGui import QFont
from PyQt5.QtWidgets import QPushButton, QRadioButton, QSpinBox, \
    QLCDNumber,  QGroupBox, QHBoxLayout, QDialog, QApplication, QWidget, QVBoxLayout, QLabel, QListWidget, QGridLayout,\
    QTableWidgetItem
from PyQt5.QtCore import pyqtSignal, QTimer, Qt
import sys
from datetime import datetime
from pygame import mixer
import time

alarms = []


class alarm:
    def __init__(self,nomer, user, time, text,days, povtor, on):
        self.nomer = nomer
        self.user = user
        self.time = time
        self.text = text
        self.days = days
        self.povtor = povtor
        self.on = True

    def check_every_day(self):
        if self.time == datetime.now().strftime("%H:%M") and self.on:
            return True
        else:
            return False

    def check_once(self):
        if self.time == datetime.now().strftime("%H:%M") and self.on:
            self.on = False
            return True
        else:
            return False

    def check(self):
        if self.povtor == "Ежедневно":
            play = self.check_every_day()
        else:
            play = self.check_once()
        if play:
            w.create_2.show()
            w.text.show()
            w.text.setText(self.text)
            w.create.hide()
            w.stopwatch.hide()
            w.calendar.hide()
            w.alarm.hide()
            w.setFocus()
            mixer.init()


            # Loading the song
            mixer.music.load("alarm.wav")

            # Setting the volume
            mixer.music.set_volume(0.7)

            # Start playing the song
            mixer.music.play(-1)




class MainWindow(QWidget):
    def __init__(self):
        super(MainWindow, self).__init__()
        self.setObjectName ( "self" )
        self.resize ( 1037, 772 )
        self.setAutoFillBackground ( False )

        self.centralwidget = QtWidgets.QWidget ( self )
        self.centralwidget.setObjectName ( "centralwidget" )

        self.alarm = QtWidgets.QPushButton ( self.centralwidget )
        self.alarm.setGeometry ( QtCore.QRect ( 140, 30, 250, 90 ) )
        self.alarm.setAutoDefault ( False )
        self.alarm.setObjectName ( "alarm" )


        self.calendar = QtWidgets.QPushButton ( self.centralwidget )
        self.calendar.setGeometry ( QtCore.QRect ( 390, 30, 250, 90 ) )
        self.calendar.setObjectName ( "calendar" )

        self.stopwatch = QtWidgets.QPushButton ( self.centralwidget )
        self.stopwatch.setGeometry ( QtCore.QRect ( 640, 30, 250, 90 ) )
        self.stopwatch.setObjectName ( "stopwatch" )

        self.create = QtWidgets.QPushButton ( self.centralwidget )
        self.create.setGeometry ( QtCore.QRect ( 390, 570, 250, 90 ) )
        self.create.setObjectName ( "pushButton" )

        self.create_2 = QtWidgets.QPushButton ( self.centralwidget )
        self.create_2.setGeometry ( QtCore.QRect ( 390, 570, 250, 90 ) )
        self.create_2.setObjectName ( "create_2" )
        self.create_2.hide()

        self.text = QtWidgets.QLabel ( self.centralwidget )
        self.text.setGeometry ( QtCore.QRect ( 310, 250, 401, 241 ) )
        self.text.setObjectName ( "text" )
        self.text.hide()
        self.text.setAlignment ( Qt.AlignCenter )



        self.retranslateUi ( self )

        QtCore.QMetaObject.connectSlotsByName ( self )

        self.add_functions()

    def retranslateUi(self, MainWindow) :
        _translate = QtCore.QCoreApplication.translate
        self.setWindowTitle ( _translate ( "MainWindow", "MainWindow" ) )
        self.alarm.setText ( _translate ( "MainWindow", "Будильники" ) )
        self.calendar.setText ( _translate ( "MainWindow", "Текущая дата и время" ) )
        self.stopwatch.setText ( _translate ( "MainWindow", "Секундомер" ) )
        self.create.setText( _translate ( "MainWindow", "Создать будильник" ) )
        self.create_2.setText ( _translate ( "MainWindow", "Выключить" ) )
        self.text.setText ( _translate ( "MainWindow", "" ) )


    def add_functions(self) :
        self.alarm.clicked.connect(self.show_table)
        self.calendar.clicked.connect(self.show_window_2)
        self.stopwatch.clicked.connect(self.show_window3)
        self.create.clicked.connect(self.show_create)
        self.create_2.clicked.connect(self.stop)

    def show_table(self):
        self.table = Table()
        self.table.show()

    def show_window_2(self):
        self.w2 = Timer1()
        self.w2.show()

    def show_window3(self):
        self.w3 = stopwatch()
        self.w3.show()

    def show_create(self):
        self.w4 = Create()
        self.w4.show()



    def stop(self):
        mixer.music.stop()
        w.alarm.show()
        w.create.show()
        w.calendar.show()
        w.stopwatch.show()
        w.create_2.hide()
        w.text.hide()


class stopwatch( QDialog ) :
    timeout = pyqtSignal ()

    def __init__(self, parent=None) :
        super ().__init__ ( parent )
        self.time = 0
        self.timeInterval = 1000  # По умолчанию секунды

        self.timerUp = QTimer ()
        self.timerUp.setInterval ( self.timeInterval )
        self.timerUp.timeout.connect ( self.updateUptime )

        self.timerDown = QTimer ()
        self.timerDown.setInterval ( self.timeInterval )
        self.timerDown.timeout.connect ( self.updateDowntime )

        self.initUi ()

        self.buttonStart.clicked.connect ( self.timerUp.start )
        self.buttonStop.clicked.connect ( self.timerUp.stop )
        self.buttonReset.clicked.connect ( self.reset )
        self.buttonCountDown.clicked.connect ( self.timerDown.start )
        self.buttonStopAlarm.clicked.connect ( self.timerDown.stop )
        self.timeSpinBox.valueChanged.connect ( self.settimer )

    def initUi(self) :
        mainLayout = QVBoxLayout ()
        self.setLayout ( mainLayout )


        self.groupBox = QGroupBox ( " Выбираем интервал " )
        self.radioButton1 = QRadioButton ( "s" )
        self.radioButton1.toggled.connect ( self.setUnit )
        self.radioButton2 = QRadioButton ( "0.1s" )
        self.radioButton2.toggled.connect ( self.setUnit )
        self.radioButton3 = QRadioButton ( "0.01s" )
        self.radioButton3.toggled.connect ( self.setUnit )
        self.radioButton4 = QRadioButton ( "1ms" )
        self.radioButton4.toggled.connect ( self.setUnit )
        self.radioButton1.setChecked ( True )
        self.unitLayout = QHBoxLayout ()
        self.unitLayout.addWidget ( self.radioButton1 )
        self.unitLayout.addWidget ( self.radioButton2 )
        self.unitLayout.addWidget ( self.radioButton3 )
        self.unitLayout.addWidget ( self.radioButton4 )
        self.groupBox.setLayout ( self.unitLayout )
        mainLayout.addWidget ( self.groupBox )

        self.buttonStart = QPushButton ( self.tr ( "start" ) )
        mainLayout.addWidget ( self.buttonStart )

        self.buttonStop = QPushButton ( self.tr ( "stop" ) )
        mainLayout.addWidget ( self.buttonStop )

        self.timeViewer = QLCDNumber ()
        self.timeViewer.setFixedHeight ( 45 )
        mainLayout.addWidget ( self.timeViewer )

        self.timeForHuman = QLabel ()
        mainLayout.addWidget ( self.timeForHuman )

        self.buttonReset = QPushButton ( self.tr ( "reset" ) )
        mainLayout.addWidget ( self.buttonReset )

        self.timeSpinBox = QSpinBox ()
        self.timeSpinBox.setRange ( 0, 1000000000 )
        mainLayout.addWidget ( self.timeSpinBox )

        self.groupBoxCountDown = QGroupBox ( " Обратный отсчет " )
        countDown = QVBoxLayout ()
        self.buttonCountDown = QPushButton ( self.tr ( "Cтарт" ) )
        self.buttonStopAlarm = QPushButton ( self.tr ( "Стоп" ) )

        countDown.addWidget ( self.buttonCountDown )
        countDown.addWidget ( self.buttonStopAlarm )
        self.groupBoxCountDown.setLayout ( countDown )
        mainLayout.addWidget ( self.groupBoxCountDown )

    def setUnit(self) :
        if self.radioButton1.isChecked () :
            self.timeInterval = 1000
        elif self.radioButton2.isChecked () :
            self.timeInterval = 100
        elif self.radioButton3.isChecked () :
            self.timeInterval = 10
        elif self.radioButton1.isChecked () :
            self.timeInterval = 1
        self.timerUp.setInterval ( self.timeInterval )
        self.timerDown.setInterval ( self.timeInterval )

    def updateUptime(self):
        self.time += 1
        self.settimer(self.time)

    def updateDowntime(self) :
        self.time = self.time - 1
        self.settimer ( self.time )
        if self.time <= 0 :
            self.timeout.emit ()

    def settimer(self, int) :
        self.time = int
        self.timeViewer.display ( self.time )
        if self.timeInterval == 1000 :
            self.timeForHuman.setText (
                time.strftime ( '%H hour %M minute %S second', time.gmtime ( self.time ) ) )
        elif self.timeInterval == 100 :
            self.timeForHuman.setText (
                time.strftime ( '%H hour %M minute %S second', time.gmtime ( self.time / 10 ) ) )
        elif self.timeInterval == 10 :
            self.timeForHuman.setText (
                time.strftime ( '%H hour %M minute %S second', time.gmtime ( self.time / 100 ) ) )
        elif self.timeInterval == 1 :
            self.timeForHuman.setText (
                time.strftime ( '%H hour %M minute %S second', time.gmtime ( self.time / 1000 ) ) )

    def reset(self) :
        self.time = 0
        self.settimer ( self.time )




class Timer1(QWidget):
    def __init__(self,parent=None):
        super(Timer1, self).__init__(parent)
        self.setWindowTitle('Timer ')
        self.setGeometry ( 100, 100, 800, 400 )
        self.listFile=QListWidget()

        self.label=QLabel()
        self.label.setAlignment(QtCore.Qt.AlignCenter)

        self.startBtn=QPushButton('Start')
        self.endBtn=QPushButton('Stop')

        self.label.setFont ( QFont ( "Arial", 25 ) )
        layout=QGridLayout()

        self.timer=QTimer()
        self.timer.timeout.connect(self.showTime)
        self.timer.timeout.connect(self.startTimer)

        layout.addWidget(self.label,0,0,1,2)
        layout.addWidget(self.startBtn,1,0)
        layout.addWidget(self.endBtn,1,1)

        self.startBtn.clicked.connect(self.startTimer)
        self.endBtn.clicked.connect(self.endTimer)
        self.timer.start(1000)
        self.setLayout(layout)

    def showTime(self):
        timeDisplay= datetime.now().strftime("%d/%m/%Y %H:%M:%S")
        self.label.setText("Текущие дата и время:\n"+timeDisplay)

    def startTimer(self):
        self.timer.start(1000)
        self.startBtn.setEnabled(False)
        self.endBtn.setEnabled(True)

    def endTimer(self):
        self.timer.stop()
        self.startBtn.setEnabled(True)
        self.endBtn.setEnabled(False)

class Create(QDialog):
    def __init__(self, parent=None) :
        super ().__init__ ( parent )
        self.setObjectName ( "self" )
        self.resize ( 740, 421 )
        self.label = QtWidgets.QLabel ( self )
        self.label.setGeometry ( QtCore.QRect ( 470, 230, 111, 31 ) )
        font = QtGui.QFont ()
        font.setPointSize ( 15 )
        font.setBold ( False )
        font.setItalic ( False )
        font.setUnderline ( False )
        font.setWeight ( 50 )
        font.setStrikeOut ( False )
        font.setKerning ( True )

        self.label.setFont ( font )
        self.label.setLayoutDirection ( QtCore.Qt.RightToLeft )
        self.label.setTextFormat ( QtCore.Qt.PlainText )
        self.label.setAlignment ( QtCore.Qt.AlignCenter )
        self.label.setObjectName ( "label" )

        self.comboBox = QtWidgets.QComboBox ( self )
        self.comboBox.setGeometry ( QtCore.QRect ( 460, 290, 140, 40 ) )
        self.comboBox.setLayoutDirection ( QtCore.Qt.LeftToRight )
        self.comboBox.setEditable ( False )
        self.comboBox.setMaxVisibleItems ( 10 )
        self.comboBox.setInsertPolicy ( QtWidgets.QComboBox.NoInsert )
        self.comboBox.setObjectName ( "comboBox" )
        self.comboBox.addItem ( "" )
        self.comboBox.addItem ( "" )

        self.label_2 = QtWidgets.QLabel ( self )
        self.label_2.setGeometry ( QtCore.QRect ( 100, 40, 171, 41 ) )
        font = QtGui.QFont ()
        font.setPointSize ( 15 )
        self.label_2.setFont ( font )
        self.label_2.setAlignment ( QtCore.Qt.AlignCenter )
        self.label_2.setObjectName ( "label_2" )

        self.label_3 = QtWidgets.QLabel ( self )
        self.label_3.setGeometry ( QtCore.QRect ( 460, 40, 111, 41 ) )
        font = QtGui.QFont ()
        font.setPointSize ( 15 )
        self.label_3.setFont ( font )
        self.label_3.setAlignment ( QtCore.Qt.AlignCenter )
        self.label_3.setObjectName ( "label_3" )

        self.label_4 = QtWidgets.QLabel ( self )
        self.label_4.setGeometry ( QtCore.QRect ( 50, 220, 291, 41 ) )
        font = QtGui.QFont ()
        font.setPointSize ( 15 )
        self.label_4.setFont ( font )
        self.label_4.setObjectName ( "label_4" )

        self.text = QtWidgets.QLineEdit ( self )
        self.text.setGeometry ( QtCore.QRect ( 120, 290, 140, 40 ) )
        self.text.setObjectName ( "text" )

        self.timeEdit = QtWidgets.QTimeEdit ( self )
        self.timeEdit.setGeometry ( QtCore.QRect ( 460, 110, 140, 40 ) )
        self.timeEdit.setObjectName ( "timeEdit" )

        self.pushButton = QtWidgets.QPushButton ( self )
        self.pushButton.setGeometry ( QtCore.QRect ( 310, 350, 131, 51 ) )
        font = QtGui.QFont ()
        font.setPointSize ( 10 )
        self.pushButton.setFont ( font )
        self.pushButton.setObjectName ( "pushButton" )

        self.mon = QtWidgets.QCheckBox ( self )
        self.mon.setGeometry ( QtCore.QRect ( 100, 90, 101, 20 ) )
        self.mon.setObjectName ( "mon" )

        self.tuesday = QtWidgets.QCheckBox ( self )
        self.tuesday.setGeometry ( QtCore.QRect ( 100, 120, 81, 20 ) )
        self.tuesday.setObjectName ( "tuesday" )

        self.wen = QtWidgets.QCheckBox ( self )
        self.wen.setGeometry ( QtCore.QRect ( 100, 150, 81, 20 ) )
        self.wen.setObjectName ( "wen" )

        self.thursday = QtWidgets.QCheckBox ( self )
        self.thursday.setGeometry ( QtCore.QRect ( 100, 180, 81, 20 ) )
        self.thursday.setObjectName ( "thursday" )

        self.friday = QtWidgets.QCheckBox ( self )
        self.friday.setGeometry ( QtCore.QRect ( 220, 90, 81, 20 ) )
        self.friday.setObjectName ( "friday" )

        self.saturday = QtWidgets.QCheckBox ( self )
        self.saturday.setGeometry ( QtCore.QRect ( 220, 135, 101, 20 ) )
        self.saturday.setObjectName ( "saturday" )

        self.sunday = QtWidgets.QCheckBox ( self )
        self.sunday.setGeometry ( QtCore.QRect ( 220, 180, 101, 20 ) )
        self.sunday.setObjectName ( "sunday" )

        QtCore.QMetaObject.connectSlotsByName ( self )
        _translate = QtCore.QCoreApplication.translate
        self.setWindowTitle ( _translate ( "Form", "Form" ) )
        self.label.setText ( _translate ( "Form", "Повтор" ) )
        self.comboBox.setItemText ( 0, _translate ( "Form", "Ежедневно" ) )
        self.comboBox.setItemText ( 1, _translate ( "Form", "Однокартно" ) )
        self.label_2.setText ( _translate ( "Form", "Дени недели" ) )
        self.label_3.setText ( _translate ( "Form", "Время" ) )
        self.label_4.setText ( _translate ( "Form", "Текст при срабатывании" ) )
        self.pushButton.setText ( _translate ( "Form", "Добавить" ) )
        self.mon.setText ( _translate ( "Form", "Понедельник" ) )
        self.tuesday.setText ( _translate ( "Form", "Вторник" ) )
        self.wen.setText ( _translate ( "Form", "Среда" ) )
        self.thursday.setText ( _translate ( "Form", "Четверг" ) )
        self.friday.setText ( _translate ( "Form", "Пятница" ) )
        self.saturday.setText ( _translate ( "Form", "Суббота" ) )
        self.sunday.setText ( _translate ( "Form", "Воскресенье" ) )

        self.pushButton.clicked.connect(self.create_budil)



    def create_budil(self):
        days = ""

        if self.mon.isChecked():
            days +=  "0"

        if self.tuesday.isChecked():
            days += "1"

        if self.wen.isChecked():
            days += "2"

        if self.thursday.isChecked():
            days += "3"

        if self.friday.isChecked():
            days += "4"

        if self.saturday.isChecked():
            days += "5"

        if self.sunday.isChecked():
            days += "6"


        if self.timeEdit.time().minute() < 10:
            minutes = "0" + str ( self.timeEdit.time ().minute () )
        else:
            minutes = str ( self.timeEdit.time ().minute () )
        if self.timeEdit.time().hour() < 10:
            hours = "0" + str ( self.timeEdit.time ().hour () )
        else:
            hours = str ( self.timeEdit.time ().hour () )
        time = hours + ":" + minutes
        text = self.text.text()
        povtor = self.comboBox.itemText(self.comboBox.currentIndex())
        alarms.append(alarm((len(alarms)+1), "admin", time, text, days, povtor, True))


class Table(QWidget):
    def __init__(self, parent=None) :
        super ().__init__ ( parent )
        self.setObjectName ( "Form" )
        self.resize ( 904, 599 )

        self.tableWidget = QtWidgets.QTableWidget ( self )
        self.tableWidget.setGeometry ( QtCore.QRect ( 50, 30, 831, 371 ) )
        self.tableWidget.setRowCount ( 0 )
        self.tableWidget.setObjectName ( "tableWidget" )
        self.tableWidget.setColumnCount ( 0 )

        self.label = QtWidgets.QLabel ( self )
        self.label.setGeometry ( QtCore.QRect ( 370, 410, 210, 71 ) )
        self.label.setAlignment ( QtCore.Qt.AlignCenter )
        self.label.setWordWrap ( True )
        self.label.setObjectName ( "label" )

        self.lineEdit = QtWidgets.QLineEdit ( self )
        self.lineEdit.setGeometry ( QtCore.QRect ( 370, 510, 210, 51 ) )
        self.lineEdit.setObjectName ( "lineEdit" )

        self.create_table()

        self.pushButton = QtWidgets.QPushButton ( self )
        self.pushButton.setGeometry ( QtCore.QRect ( 630, 510, 210, 51 ) )
        self.pushButton.setObjectName ( "pushButton" )
        self.pushButton.clicked.connect ( self.delete )

        self.retranslateUi ( self )
        QtCore.QMetaObject.connectSlotsByName ( self )


    def retranslateUi(self, Form) :
        _translate = QtCore.QCoreApplication.translate
        self.setWindowTitle ( _translate ( "Form", "Form" ) )
        self.label.setText ( _translate ( "Form", "Для удаления будильника введите его номер  " ) )
        self.pushButton.setText ( _translate ( "Form", "Удалить" ) )

    def create_table(self):
        self.tableWidget.setColumnCount ( 7 )
        self.tableWidget.setRowCount ( len ( alarms ) )
        self.tableWidget.setHorizontalHeaderLabels (["Номер", "Пользователь", "Время", "Текст", "Повтор","Дни", "Включён"] )
        for i in range ( len ( alarms ) ) :
            self.tableWidget.setItem(i, 0, QTableWidgetItem(str(alarms[i].nomer)))
            self.tableWidget.setItem(i, 1, QTableWidgetItem(alarms[i].user) )
            self.tableWidget.setItem(i, 2, QTableWidgetItem(alarms[i].time))
            self.tableWidget.setItem(i, 3, QTableWidgetItem(alarms[i].text))
            self.tableWidget.setItem(i,4,QTableWidgetItem(alarms[i].povtor))
            days = ""
            if "0" in alarms[i].days:
                days += "Понедельник \n"
            if "1" in alarms[i].days:
                days += "Вторник \n"
            if "2" in alarms[i].days:
                days += "Среда \n"
            if "3" in alarms[i].days:
                days += "Четверг \n"
            if "4" in alarms[i].days:
                days += "Пятница \n"
            if "5" in alarms[i].days:
                days += "Суббота \n"
            if "6" in alarms[i].days:
                days += "Воскресенье \n"
            if alarms[i].povtor == "01234":
                povtor = "По будням"
            if alarms[i].povtor == "56":
                povtor = "По выходным"
            self.tableWidget.setItem(i, 5, QTableWidgetItem(days))
            if alarms[i].on:
                self.tableWidget.setItem(i, 6, QTableWidgetItem("Да"))
            else:
                self.tableWidget.setItem(i, 6, QTableWidgetItem ("Нет") )
            self.tableWidget.resizeColumnsToContents ()

    def delete(self):
        try:
            alarms.pop((int(self.lineEdit.text())-1))
        except :
            self.create_table()
        self.create_table ()


def main_check():
    threading.Timer(5 ,main_check).start()
    for i in range(len(alarms)):
        alarms[i].check()


if __name__ == '__main__':
    app = QApplication(sys.argv)
    w = MainWindow()
    w.show()
    main_check()
    sys.exit(app.exec_())

